<!DOCTYPE html>
<html>
	<body>
		<p>Click the button to solve 5 question of satck</p>
		<button onclick="nearestSmaller()">print nearest smaller no</button>
		<p id="demo"></p>

		<script>
			function nearestSmaller() {
				class Stack {
				// Array is used to implement stack
					constructor() {
						this.items = [];
					}
				
					// push function
					push(element) {
						// push element into the items
						this.items.push(element);
					}
				
					// pop
					pop() {
						// function return top most element in the stack and removes it from the stack Underflow if stack is empty
						if(this.items.length == 0)
							return "Underflow";
						return this.items.pop();
					}
				
					// peek function
					peek() {
						// return the top most element from the stack but does'nt delete it.
						return this.items[this.items.length - 1];
					}
					
					// isEmpty function
					isEmpty() {
						// return true if stack is empty
						return this.items.length == 0;
					}

				}
				

                // Prints smaller elements on left side of every element 
                function printSmallerOnLeft(arr,n) { 
                    // creating object for stack class
				    var stack = new Stack();
                    var output = "";
                    // Traverse all array elements 
                    for (var i=0; i<n; i++) { 
                        // removing top element from Stack while the top element is greater than or equal to arr[i] 
                        while (!stack.isEmpty() && stack.peek() >= arr[i]) 
                            stack.pop(); 
                
                        // If all elements in S were greater than arr[i] 
                        if (stack.isEmpty()) 
                            output += "-1 "; 
                        else {
                             //Else print the nearest smaller element 
                            output += stack.peek(); 
                            output += " ";
                        }
                
                        // Push this element 
                        stack.push(arr[i]); 
                    } 
                    return output;
                }

                //create an array
                var array = [2,4,7,3,9,1,6,8,10];
                console.log("your given array is = "+array);
                console.log(printSmallerOnLeft(array,array.length));

		}
		</script>

	</body>
</html>